"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const client_1 = require("@deep-foundation/hasura/client");
const benchmark_1 = require("benchmark");
const client_2 = require("../imports/client");
const delay = time => new Promise(res => setTimeout(res, time));
const apolloClient = (0, client_1.generateApolloClient)({
    path: `${process.env.HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.HASURA_SSL,
    secret: process.env.HASURA_SECRET,
});
const deep = new client_2.DeepClient({ apolloClient });
(() => __awaiter(void 0, void 0, void 0, function* () {
    var suite = new benchmark_1.Suite();
    suite.add('3000', { defer: true, fn: function (deferred) {
            return __awaiter(this, void 0, void 0, function* () {
                yield delay(3000);
                deferred.resolve();
            });
        } });
    suite.add('deepClient.id', { defer: true, fn: function (deferred) {
            return __awaiter(this, void 0, void 0, function* () {
                yield deep.id('@deep-foundation/core', 'Promise');
                deferred.resolve();
            });
        } });
    suite.on('cycle', function (event) {
        console.log(String(event.target));
    });
    suite.on('complete', function () {
        console.log('Fastest is ' + this.filter('fastest').map('name'));
    });
    suite.run({ 'async': false });
}))();
//# sourceMappingURL=index.js.map