"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.api = void 0;
const client_1 = require("@deep-foundation/hasura/client");
const api_1 = require("@deep-foundation/hasura/api");
const gql_1 = require("../gql");
const SCHEMA = 'public';
exports.api = new api_1.HasuraApi({
    path: process.env.DEEPLINKS_HASURA_PATH,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
const client = (0, client_1.generateApolloClient)({
    path: `${process.env.DEEPLINKS_HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.DEEPLINKS_HASURA_SSL,
    secret: process.env.DEEPLINKS_HASURA_SECRET,
});
exports.default = (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c, _d, _e, _f, _g;
    try {
        const count = (_b = (_a = req === null || req === void 0 ? void 0 : req.body) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.count;
        if (!count)
            res.status(500).json({ error: 'no count' });
        const links = [];
        for (let i = 0; i < count; i++)
            links[i] = { type_id: 0 };
        const mutateLinksResult = yield client.mutate((0, gql_1.generateSerial)({
            actions: [(0, gql_1.insertMutation)('links', { objects: links })],
            name: 'INSERT_LINKS',
        }));
        const ids = (_d = (_c = mutateLinksResult.data['m0']) === null || _c === void 0 ? void 0 : _c.returning) === null || _d === void 0 ? void 0 : _d.map(node => node.id);
        if (!ids)
            res.status(500).json({ error: 'insert links error' });
        const mutateReservedResult = yield client.mutate((0, gql_1.generateSerial)({
            actions: [
                (0, gql_1.generateMutation)({
                    tableName: 'reserved', operation: 'insert',
                    variables: { objects: { reserved_ids: ids, user_id: 123123, created_at: new Date().toISOString() } },
                }),
            ],
            name: 'INSERT_RESERVED',
        }));
        if (!((_g = (_f = (_e = mutateLinksResult.data['m0']) === null || _e === void 0 ? void 0 : _e.returning) === null || _f === void 0 ? void 0 : _f[0]) === null || _g === void 0 ? void 0 : _g.id))
            res.status(500).json({ error: 'insert resrved error' });
        return res.json({ ids });
    }
    catch (error) {
        return res.status(500).json({ error: error.toString() });
    }
});
//# sourceMappingURL=reserved.js.map